library redux_enhancement;

/// Abstract class every Action that should be used with this package must extend.
/// Use the IDE to your advantage and let the constructor be auto-generated - less typing!
/// ```
/// import 'package:redux_enhancement/redux_action.dart';
///
/// class UpdateShopNameAction extends ReduxAction<String> {
///   UpdateShopNameAction(String value) : super(value);
/// }
/// ```
abstract class ReduxAction<T> {
  final Type type;
  final T value;

  ReduxAction(this.value) : type = T;
}
